=== debian/changelog ===
osrm (4.7.1-2) unstable; urgency=medium

  * Team upload.
  * Use dh_installdirs to create var/{lib,log}/osrm.
    (closes: #798452)
  * Update Vcs-Browser URL to use HTTPS.

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 09 Sep 2015 21:43:48 +0200

osrm (4.7.1-1) unstable; urgency=medium

  * Team upload.
  * Improve version matching & mangling in watch file.
  * New upstream release.
  * Update copyright file, add copyright holders
  * Drop unused lintian override for hardening-no-fortify-functions
    false positive.
  * Rebuild with osmpbf & libstxxl for GCC 5 transitions.
    (closes: #796544)

 -- Bas Couwenberg <sebastic@debian.org>  Mon, 24 Aug 2015 11:12:40 +0200

osrm (4.6.1-1) unstable; urgency=medium

  * Team upload

  [ Andreas Tille ]
  * Initial release (Closes: #701506)

  [ Christopher Baines ]
  * New upstream release.

  [ Bas Couwenberg ]
  * Add gbp.conf to use pristine-tar by default.
  * Update Vcs-Browser URL to use cgit instead of gitweb.
  * Use stand-alone license paragraph in copyright file.
  * Update watch file for GitHub repo move, add mangling.
  * Improve upstream metadata, add Bug & Repository URLs.
  * Move man pages to subdirectory.
  * Update copyright file, changes:
    - Add Upstream-Contact field
    - Add license & copyright for third_party projects

 -- Christopher Baines <mail@cbaines.net>  Sat, 18 Jul 2015 21:58:50 +0100
