=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_HARDENING=1

%:
	dh $@ --parallel --with=systemd

override_dh_clean:
	dh_clean util/fingerprint_impl.hpp util/git_sha.cpp

override_dh_auto_configure:
	dh_auto_configure -- -DWITH_TOOLS=1 -DCMAKE_VERBOSE_MAKEFILE=1
