## osrm 5.0.0

=== DESCRIPTION ===
Package: osrm
Type: Package
Title: Interface Between R and the OpenStreetMap-Based Routing Service
        OSRM
Version: 5.0.0
Authors@R: c(person("Timothée", "Giraud", email = "timothee.giraud@cnrs.fr",
    role = c("cre","aut"),  comment = c(ORCID = "0000-0002-1932-3323")),
    person("Robin", "Cura", role = c("ctb"),
    comment = c(ORCID = "0000-0001-5926-1828")),
    person("Matthieu", "Viry", role = c("ctb"),
    comment = c(ORCID = "0000-0002-0693-8556")),
    person("Robin", "Lovelace", role = c("ctb"),
    comment = c(ORCID = "0000-0001-5679-6536"))
    )
Description: An interface between R and the 'OSRM' API. 'OSRM' is a routing
    service based on 'OpenStreetMap' data. See <http://project-osrm.org/> for more
    information. This package enables the computation of routes, trips, isochrones and
    travel distances matrices (travel time and kilometric distance).
License: GPL (>= 3)
Imports: RcppSimdJson, curl, utils, mapiso, googlePolylines, sf
Depends: R (>= 3.5.0)
Suggests: mapsf, tinytest, covr, terra
URL: https://github.com/riatelab/osrm
BugReports: https://github.com/riatelab/osrm/issues
Encoding: UTF-8
RoxygenNote: 7.3.3
NeedsCompilation: no
Packaged: 2025-12-17 13:19:45 UTC; tim
Author: Timothée Giraud [cre, aut] (ORCID:
    <https://orcid.org/0000-0002-1932-3323>),
  Robin Cura [ctb] (ORCID: <https://orcid.org/0000-0001-5926-1828>),
  Matthieu Viry [ctb] (ORCID: <https://orcid.org/0000-0002-0693-8556>),
  Robin Lovelace [ctb] (ORCID: <https://orcid.org/0000-0001-5679-6536>)
Maintainer: Timothée Giraud <timothee.giraud@cnrs.fr>
Repository: CRAN
Date/Publication: 2025-12-17 14:00:02 UTC
